HTTP::WebSocket -

# class HTTP::WebSocket

- HTTP::WebSocket
- Reference
- Object

## Defined in:

## Constructors

- .new(host : String, path : String, port = nil, tls = false, headers = HTTP::Headers.new)

  Opens a new websocket to the target host.

- .new(uri : URI | String, headers = HTTP::Headers.new)

  Opens a new websocket using the information provided by the URI.

## Instance Method Summary

- #close(message = nil)
- #closed? : Bool
- #on_binary(&on_binary : Bytes -> )
- #on_close(&on_close : String -> )
- #on_message(&on_message : String -> )
- #on_ping(&on_ping : String -> )
- #on_pong(&on_pong : String -> )
- #ping(message = nil)

  It's possible to send a PING frame, which the client must respond to with a PONG, or the server can send an unsolicited PONG frame which the client should not respond to.

- #pong(message = nil)

  Server can send an unsolicited PONG frame which the client should not respond to.

- #run
- #send(message)
- #stream(binary = true, frame_size = 1024, &block)

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, class class, dup dup, hash(hasher)
hash hash, inspect(io : IO) : Nil
inspect : String inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&block) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&block) try, unsafe_as(type : T.class) forall T unsafe_as

### Constructor methods inherited from class `Object`

from_json(string_or_io, root : String) : self
from_json(string_or_io) : self from_json, from_yaml(string_or_io : String | IO) : self from_yaml

## Constructor Detail

def self.new(host : String, path : String, port = nil, tls = false, headers = HTTP::Headers.new) #

Opens a new websocket to the target host. This will also handle the handshake and will raise an exception if the handshake did not complete successfully.

    require "http/web_socket"

    HTTP::WebSocket.new("websocket.example.com", "/chat")            # Creates a new WebSocket to `websocket.example.com`
    HTTP::WebSocket.new("websocket.example.com", "/chat", tls: true) # Creates a new WebSocket with TLS to `ẁebsocket.example.com`

def self.new(uri : URI | String, headers = HTTP::Headers.new) #

Opens a new websocket using the information provided by the URI. This will also handle the handshake and will raise an exception if the handshake did not complete successfully. This method will also raise an exception if the URI is missing the host and/or the path.

Please note that the scheme will only be used to identify if TLS should be used or not. Therefore, schemes apart from `wss` and `https` will be treated as the default which is `ws`.

    require "http/web_socket"

    HTTP::WebSocket.new(URI.parse("ws://websocket.example.com/chat"))        # Creates a new WebSocket to `websocket.example.com`
    HTTP::WebSocket.new(URI.parse("wss://websocket.example.com/chat"))       # Creates a new WebSocket with TLS to `websocket.example.com`
    HTTP::WebSocket.new(URI.parse("http://websocket.example.com:8080/chat")) # Creates a new WebSocket to `websocket.example.com` on port `8080`
    HTTP::WebSocket.new(URI.parse("ws://websocket.example.com/chat"),        # Creates a new WebSocket to `websocket.example.com` with an Authorization header
      HTTP::Headers{"Authorization" => "Bearer authtoken"})

## Instance Method Detail

def close(message = nil) #
def closed? : Bool #
def on_binary(&on_binary : Bytes -> ) #
def on_close(&on_close : String -> ) #
def on_message(&on_message : String -> ) #
def on_ping(&on_ping : String -> ) #
def on_pong(&on_pong : String -> ) #
def ping(message = nil) #

It's possible to send a PING frame, which the client must respond to with a PONG, or the server can send an unsolicited PONG frame which the client should not respond to.

See `#pong`.

def pong(message = nil) #

Server can send an unsolicited PONG frame which the client should not respond to.

See `#ping`.

def run #
def send(message) #
def stream(binary = true, frame_size = 1024, &block) #